Loading...
Searching...
No Matches
globus_gsi_proxy.h File Reference

Globus GSI Proxy API. More...

Go to the source code of this file.

## Macros

#define | GLOBUS_GSI_PROXY_MODULE
| Module descriptor.

## Typedefs

typedef struct globus_l_gsi_proxy_handle_s * | globus_gsi_proxy_handle_t
| GSI Proxy Handle.
typedef struct globus_l_gsi_proxy_handle_attrs_s * | globus_gsi_proxy_handle_attrs_t
| Handle Attributes.

## Functions

globus_result_t | globus_gsi_proxy_handle_init (globus_gsi_proxy_handle_t *handle, globus_gsi_proxy_handle_attrs_t handle_attrs)
| Initialize a GSI Proxy handle.
globus_result_t | globus_gsi_proxy_handle_destroy (globus_gsi_proxy_handle_t handle)
| Destroy a GSI Proxy handle.
globus_result_t | globus_gsi_proxy_handle_get_req (globus_gsi_proxy_handle_t handle, X509_REQ **req)
| Get the certificate request from a GSI Proxy handle.
globus_result_t | globus_gsi_proxy_handle_set_req (globus_gsi_proxy_handle_t handle, X509_REQ *req)
| Set Request Set the certificate request in a GSI Proxy handle.
globus_result_t | globus_gsi_proxy_handle_get_private_key (globus_gsi_proxy_handle_t handle, EVP_PKEY **proxy_key)
| Get the private key from a GSI Proxy handle.
globus_result_t | globus_gsi_proxy_handle_set_private_key (globus_gsi_proxy_handle_t handle, const EVP_PKEY *proxy_key)
| Set the private key in a GSI Proxy handle.
globus_result_t | globus_gsi_proxy_handle_get_type (globus_gsi_proxy_handle_t handle, globus_gsi_cert_utils_cert_type_t *type)
| Get Proxy Type.
globus_result_t | globus_gsi_proxy_handle_set_type (globus_gsi_proxy_handle_t handle, globus_gsi_cert_utils_cert_type_t type)
| Get Proxy Type.
globus_result_t | globus_gsi_proxy_handle_get_time_valid (globus_gsi_proxy_handle_t handle, int *time_valid)
| Get Time Valid.
globus_result_t | globus_gsi_proxy_handle_set_time_valid (globus_gsi_proxy_handle_t handle, int time_valid)
| Set Time Valid.
globus_result_t | globus_gsi_proxy_handle_set_policy (globus_gsi_proxy_handle_t handle, const unsigned char *policy_data, int policy_length, int policy_NID)
| Set Policy.
globus_result_t | globus_gsi_proxy_handle_get_policy (globus_gsi_proxy_handle_t handle, unsigned char **policy_data, int *policy_length, int *policy_NID)
| Get Policy.
globus_result_t | globus_gsi_proxy_handle_add_extension (globus_gsi_proxy_handle_t handle, X509_EXTENSION *extension)
| Add X.509 Extensions.
globus_result_t | globus_gsi_proxy_handle_set_extensions (globus_gsi_proxy_handle_t handle, STACK_OF(X509_EXTENSION) *extensions)
| Set X.509 Extensions.
globus_result_t | globus_gsi_proxy_handle_get_extensions (globus_gsi_proxy_handle_t handle, STACK_OF(X509_EXTENSION) **extension)
| Get X.509 Extensions.
globus_result_t | globus_gsi_proxy_handle_set_pathlen (globus_gsi_proxy_handle_t handle, long pathlen)
| Set Path Length.
globus_result_t | globus_gsi_proxy_handle_get_pathlen (globus_gsi_proxy_handle_t handle, int *pathlen)
| Get Path Length.
globus_result_t | globus_gsi_proxy_handle_clear_cert_info (globus_gsi_proxy_handle_t handle)
| Clear Cert Info.
globus_result_t | globus_gsi_proxy_handle_get_common_name (globus_gsi_proxy_handle_t handle, char **common_name)
| Get/Set Proxy Common Name.
globus_result_t | globus_gsi_proxy_handle_set_common_name (globus_gsi_proxy_handle_t handle, const char *common_name)
globus_result_t | globus_gsi_proxy_is_limited (globus_gsi_proxy_handle_t handle, globus_bool_t *is_limited)
globus_result_t | globus_gsi_proxy_handle_set_is_limited (globus_gsi_proxy_handle_t handle, globus_bool_t is_limited)
| Set/Check Proxy Is Limited.
globus_result_t | globus_gsi_proxy_handle_get_signing_algorithm (globus_gsi_proxy_handle_t handle, const EVP_MD **algorithm)
| Get Signing Algorithm.
globus_result_t | globus_gsi_proxy_handle_get_keybits (globus_gsi_proxy_handle_t handle, int *key_bits)
| Get Key Bits.
globus_result_t | globus_gsi_proxy_handle_get_init_prime (globus_gsi_proxy_handle_t handle, int *init_prime)
| Get Init Prime.
globus_result_t | globus_gsi_proxy_handle_get_clock_skew_allowable (globus_gsi_proxy_handle_t handle, int *skew)
| Get Clock Skew.
globus_result_t | globus_gsi_proxy_handle_get_key_gen_callback (globus_gsi_proxy_handle_t handle, void(**callback)(int, int, void *))
| Get Callback for Creating Keys.
globus_result_t | globus_gsi_proxy_handle_attrs_init (globus_gsi_proxy_handle_attrs_t *handle_attrs)
| Initialize Attributes.
globus_result_t | globus_gsi_proxy_handle_attrs_destroy (globus_gsi_proxy_handle_attrs_t handle_attrs)
| Destroy attributes.
globus_result_t | globus_gsi_proxy_handle_attrs_copy (globus_gsi_proxy_handle_attrs_t a, globus_gsi_proxy_handle_attrs_t *b)
| Copy Attributes.
globus_result_t | globus_gsi_proxy_create_req (globus_gsi_proxy_handle_t handle, BIO *output_bio)
| Create a proxy credential request.
globus_result_t | globus_gsi_proxy_inquire_req (globus_gsi_proxy_handle_t handle, BIO *input_bio)
| Inquire a proxy credential request.
globus_result_t | globus_gsi_proxy_sign_req (globus_gsi_proxy_handle_t handle, globus_gsi_cred_handle_t issuer_credential, BIO *output_bio)
| Sign a proxy certificate request.
globus_result_t | globus_gsi_proxy_resign_cert (globus_gsi_proxy_handle_t handle, globus_gsi_cred_handle_t issuer_credential, globus_gsi_cred_handle_t peer_credential, globus_gsi_cred_handle_t *resigned_credential)
| Resign an existing certificate into a proxy.
globus_result_t | globus_gsi_proxy_assemble_cred (globus_gsi_proxy_handle_t handle, globus_gsi_cred_handle_t *proxy_credential, BIO *input_bio)
| Assemble a proxy credential.
globus_result_t | globus_gsi_proxy_create_signed (globus_gsi_proxy_handle_t handle, globus_gsi_cred_handle_t issuer, globus_gsi_cred_handle_t *proxy_credential)
| Create Signed Proxy Certificate.
globus_result_t | globus_gsi_proxy_handle_attrs_set_keybits (globus_gsi_proxy_handle_attrs_t handle_attrs, int bits)
| Set Key Bits.
globus_result_t | globus_gsi_proxy_handle_attrs_get_keybits (globus_gsi_proxy_handle_attrs_t handle_attrs, int *bits)
| Get Key Bits.
globus_result_t | globus_gsi_proxy_handle_attrs_set_init_prime (globus_gsi_proxy_handle_attrs_t handle_attrs, int prime)
| Set Initial Prime Number.
globus_result_t | globus_gsi_proxy_handle_attrs_get_init_prime (globus_gsi_proxy_handle_attrs_t handle_attrs, int *prime)
| Get Initial Prime Number.
globus_result_t | globus_gsi_proxy_handle_attrs_set_signing_algorithm (globus_gsi_proxy_handle_attrs_t handle_attrs, const EVP_MD *algorithm)
| Set Signing Algorithm.
globus_result_t | globus_gsi_proxy_handle_attrs_get_signing_algorithm (globus_gsi_proxy_handle_attrs_t handle_attrs, const EVP_MD **algorithm)
| Get Signing Algorithm.
globus_result_t | globus_gsi_proxy_handle_attrs_set_clock_skew_allowable (globus_gsi_proxy_handle_attrs_t handle, int skew)
| Set Clock Skew Allowable.
globus_result_t | globus_gsi_proxy_handle_attrs_get_clock_skew_allowable (globus_gsi_proxy_handle_attrs_t handle, int *skew)
| Get Clock Skew Allowable.
globus_result_t | globus_gsi_proxy_handle_attrs_get_key_gen_callback (globus_gsi_proxy_handle_attrs_t handle, void(**callback)(int, int, void *))
| Get Key Gen Callback.
globus_result_t | globus_gsi_proxy_handle_attrs_set_key_gen_callback (globus_gsi_proxy_handle_attrs_t handle, void(*callback)(int, int, void *))
| Set Key Gen Callback.

## Detailed Description

Globus GSI Proxy API.

## Function Documentation

## globus_gsi_proxy_handle_destroy()

globus_result_t globus_gsi_proxy_handle_destroy | ( | globus_gsi_proxy_handle_t | handle | ) |

Destroy a GSI Proxy handle.

Free the memory used by a GSI proxy handle.

Parameters

  [in] | handle | The handle to be destroyed.

Returns
  GLOBUS_SUCCESS unless an error occurred, in which case, a globus error object ID is returned

See also
  globus_gsi_proxy_handle_init()

## globus_gsi_proxy_handle_set_common_name()

globus_result_t globus_gsi_proxy_handle_set_common_name | ( | globus_gsi_proxy_handle_t | handle,
|  | const char * | common_name )

Set the proxy common name stored in the GSI Proxy handle.

This function sets the proxy common name in the GSI Proxy handle. Note that the common name is only used for draft compliant proxies.

Parameters

  handle | The handle for which to set the proxy common name.
  common_name | The proxy common name to set.

Returns
  GLOBUS_SUCCESS upon success GLOBUS_GSI_PROXY_ERROR_WITH_HANDLE if handle is invalid

## globus_gsi_proxy_handle_set_private_key()

globus_result_t globus_gsi_proxy_handle_set_private_key | ( | globus_gsi_proxy_handle_t | handle,
|  | const EVP_PKEY * | proxy_key )

Set the private key in a GSI Proxy handle.

Copies the private key pointed to by proxy_key to the handle.

Parameters

  [in] | handle | The handle for which to set the private key
  [in] | proxy_key | Parameter used to pass the key

Returns
  GLOBUS_SUCCESS unless an error occurred, in which case, a globus error object ID is returned

See also
  globus_gsi_proxy_handle_get_private_key()

## globus_gsi_proxy_handle_set_req()

globus_result_t globus_gsi_proxy_handle_set_req | ( | globus_gsi_proxy_handle_t | handle,
|  | X509_REQ * | req )

Set Request Set the certificate request in a GSI Proxy handle.

Parameters

  [in] | handle | The handle for which to set the certificate request
  [in] | req | Request to be copied to handle.

Returns
  GLOBUS_SUCCESS unless an error occurred, in which case, a globus error object ID is returned

See also
  globus_gsi_proxy_handle_get_req()

## globus_gsi_proxy_is_limited()

globus_result_t globus_gsi_proxy_is_limited | ( | globus_gsi_proxy_handle_t | handle,
|  | globus_bool_t * | is_limited )

Check to see the proxy is a limited proxy

Parameters

  handle | the proxy handle to check
  is_limited | boolean value to set depending on the type of proxy

Returns
  GLOBUS_SUCCESS unless an error occurred, in which case, a globus error object ID is returned